Index: trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F	(revision 2464)
@@ -2,5 +2,5 @@
 
       subroutine jthermcalc_e107
-     $     (ig,chemthermod,rm,nesptherm,tx,iz,zenit,zday)
+     $     (ig,nlayer,chemthermod,rm,nesptherm,tx,iz,zenit)
 
 
@@ -11,44 +11,50 @@
 c MAC July 2003
 c**********************************************************************
-	use dimphy
-	use conc
+
+      use param_v4_h, only: jfotsout,crscabsi2,
+     .    c1_16,c17_24,c25_29,c30_31,c32,c33,c34,c35,c36,
+     .    co2crsc195,co2crsc295,t0,
+     .    jabsifotsintpar,ninter,nz2,
+     .    nabs,e107,date_e107,e107_tab,
+     .    coefit0,coefit1,coefit2,coefit3,coefit4
+
       implicit none
 
-c     common variables and constants
-#include "param.h"
-#include "param_v4.h"
+      include "clesphys.h"
+
 
 c     input and output variables
 
-      integer    ig
-      integer    chemthermod
-      integer    nesptherm                      !Number of species considered
-      real       rm(klev,nesptherm)         !Densities (cm-3)
-      real       tx(klev)                   !temperature
-      real       zenit                          !SZA
-      real       iz(klev)                   !Local altitude
-      real       zday                           !Martian day after Ls=0
-
+      integer,intent(in) :: ig,nlayer
+      integer,intent(in) :: chemthermod
+      integer,intent(in) :: nesptherm          !Number of species considered
+      real,intent(in) :: rm(nlayer,nesptherm)  !Densities (cm-3)
+      real,intent(in) :: tx(nlayer)            !temperature
+      real,intent(in) :: zenit         !SZA
+      real,intent(in) :: iz(nlayer)    !Local altitude
+
+! NB: no output variable! (computed jfotsout() is in module param_v4_h)
 
 c    local parameters and variables
 
-      real       co2colx(klev)              !column density of CO2 (cm^-2)
-      real       o2colx(klev)               !column density of O2(cm^-2)
-      real       o3pcolx(klev)              !column density of O(3P)(cm^-2)
-      real       h2colx(klev)               !H2 column density (cm-2)
-      real       h2ocolx(klev)              !H2O column density (cm-2)
-      real       h2o2colx(klev)             !column density of H2O2(cm^-2)
-      real       o3colx(klev)               !O3 column density (cm-2)
-      real       n2colx(klev)               !N2 column density (cm-2)
-      real       ncolx(klev)                !N column density (cm-2)
-      real       nocolx(klev)               !NO column density (cm-2)
-      real       cocolx(klev)               !CO column density (cm-2)
-      real       hcolx(klev)                !H column density (cm-2)
-      real       no2colx(klev)              !NO2 column density (cm-2)
-      real       t2(klev)
-      real       coltemp(klev)
-      real       sigma(ninter,klev)
-      real       alfa(ninter,klev)
-      real       realday
+      real, parameter :: dist_sol=0.72333
+
+      real       co2colx(nlayer)              !column density of CO2 (cm^-2)
+      real       o2colx(nlayer)               !column density of O2(cm^-2)
+      real       o3pcolx(nlayer)              !column density of O(3P)(cm^-2)
+      real       h2colx(nlayer)               !H2 column density (cm-2)
+      real       h2ocolx(nlayer)              !H2O column density (cm-2)
+      real       h2o2colx(nlayer)             !column density of H2O2(cm^-2)
+      real       o3colx(nlayer)               !O3 column density (cm-2)
+      real       n2colx(nlayer)               !N2 column density (cm-2)
+      real       ncolx(nlayer)                !N column density (cm-2)
+      real       nocolx(nlayer)               !NO column density (cm-2)
+      real       cocolx(nlayer)               !CO column density (cm-2)
+      real       hcolx(nlayer)                !H column density (cm-2)
+      real       no2colx(nlayer)              !NO2 column density (cm-2)
+      real       t2(nlayer)
+      real       coltemp(nlayer)
+      real       sigma(ninter,nlayer)
+      real       alfa(ninter,nlayer)
       
       integer    i,j,k,indexint                 !indexes
@@ -74,21 +80,25 @@
       real*8      auxjh(nz2)
       real*8      auxjno2(nz2)
-      real*8      wp(klev),wm(klev)
-      real*8      auxcolinp(klev)
-      integer     auxind(klev)
+      real*8      wp(nlayer),wm(nlayer)
+      real*8      auxcolinp(nlayer)
+      integer     auxind(nlayer)
       integer     auxi
       integer     ind
-      real*8      cortemp(klev)
+      real*8      cortemp(nlayer)
 
       real*8      limdown                      !limits for interpolation
       real*8      limup                        !        ""
 
-      !!!ATTENTION. Here i_co2 has to have the same value than in chemthermos.F90
+      !!!ATTENTION. Here i_co2 has to have the same value than in euvheat.F90
       !!!If the value is changed there, if has to be changed also here !!!!
       integer,parameter :: i_co2=1
 
+      character*20 modname
+      character*80 abort_message
 
 c*************************PROGRAM STARTS*******************************
       
+      modname = 'jthermcalc_e107'
+
       if(zenit.gt.140.) then
          dn='n'
@@ -105,5 +115,5 @@
       !Auxiliar temperature to take into account the temperature dependence
       !of CO2 cross section
-      do i=1,klev
+      do i=1,nlayer
          t2(i)=tx(i)
          if(t2(i).lt.195.0) t2(i)=195.0
@@ -113,11 +123,10 @@
       !Calculation of column amounts 
       call column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
-     $     co2colx,o2colx,o3pcolx,h2colx,h2ocolx,
-     $     h2o2colx,o3colx,n2colx,ncolx,nocolx,cocolx,hcolx,no2colx)
+     $     co2colx,o3pcolx,n2colx,cocolx)
 
       !Auxiliar column to include the temperature dependence 
       !of CO2 cross section
-      coltemp(klev)=co2colx(klev)*abs(t2(klev)-t0(klev))
-      do i=klev-1,1,-1
+      coltemp(nlayer)=co2colx(nlayer)*abs(t2(nlayer)-t0(nlayer))
+      do i=nlayer-1,1,-1
         coltemp(i)=!coltemp(i+1)+     PQ SE ELIMINA? REVISAR 
      $         ( rm(i,i_co2) + rm(i+1,i_co2) ) * 0.5 
@@ -126,5 +135,5 @@
       
       !Calculation of CO2 cross section at temperature t0(i)
-      do i=1,klev
+      do i=1,nlayer
          do indexint=24,32
            sigma(indexint,i)=co2crsc195(indexint-23)
@@ -134,27 +143,15 @@
       end do
 
-      !E10.7 for the day: linear interpolation to tabulated values
-      realday=mod(zday,669.)
-      if(realday.lt.date_e107(1)) then
-         e107=e107_tab(1)
-      else if(realday.ge.date_e107(669)) then
-         e107=e107_tab(669)   
-      else if(realday.ge.date_e107(1).and.
-     $        realday.lt.date_e107(669)) then
-         do i=1,668
-            if(realday.ge.date_e107(i).and.
-     $           realday.lt.date_e107(i+1)) then
-               tinf=i
-               tsup=i+1
-               e107=e107_tab(tinf)+(realday-date_e107(tinf))*
-     $              (e107_tab(tsup)-e107_tab(tinf))
-            endif
-         enddo
-      endif
+      if (solvarmod==0) then
+        e107=fixed_euv_value
+      else
+            abort_message='solvarmod should be 0...'
+            call abort_physic(modname,abort_message,1)
+      endif ! of if (solvarmod==0)
 
       !Photoabsorption coefficients at TOA as a function of E10.7
       do j=1,nabs
          do indexint=1,ninter
-            jfotsout(indexint,j,klev)=coefit0(indexint,j)+
+            jfotsout(indexint,j,nlayer)=coefit0(indexint,j)+
      $           coefit1(indexint,j)*e107+coefit2(indexint,j)*e107**2+
      $           coefit3(indexint,j)*e107**3+coefit4(indexint,j)*e107**4
@@ -178,6 +175,6 @@
 c     Input atmospheric column
       indexint=1
-      do i=1,klev
-         auxcolinp(klev-i+1) = co2colx(i)*crscabsi2(1,indexint) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint) +
      $        o2colx(i)*crscabsi2(2,indexint) + 
      $        o3pcolx(i)*crscabsi2(3,indexint) + 
@@ -213,16 +210,16 @@
 
       call interfast 
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi=klev-i+1
+         auxi=nlayer-i+1
          !CO2 interpolated coefficient
-         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,klev) *
+         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,klev) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !O3p interpolated coefficient
-         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,klev) *
+         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayer) *
      $        (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
          !H2 interpolated coefficient
@@ -233,8 +230,8 @@
       !N interpolated coefficient
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
-            jfotsout(indexint,9,klev-i+1) =  
-     $           jfotsout(indexint,9,klev) * 
+            jfotsout(indexint,9,nlayer-i+1) =  
+     $           jfotsout(indexint,9,nlayer) * 
      $           (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
          enddo
@@ -255,6 +252,6 @@
 c     Input atmospheric column
       do indexint=2,15
-         do i=1,klev
-            auxcolinp(klev-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+         do i=1,nlayer
+            auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $           o2colx(i)*crscabsi2(2,indexint)+
      $           o3pcolx(i)*crscabsi2(3,indexint)+
@@ -302,54 +299,54 @@
          endif
 
-          call interfast(wm,wp,auxind,auxcolinp,klev,
+          call interfast(wm,wp,auxind,auxcolinp,nlayer,
      $        auxcoltab,nz2,limdown,limup)
-          do i=1,klev
+          do i=1,nlayer
              ind=auxind(i)
-             auxi = klev-i+1
+             auxi = nlayer-i+1
              !O2 interpolated coefficient
              jfotsout(indexint,2,auxi) = 
-     $            jfotsout(indexint,2,klev) *
+     $            jfotsout(indexint,2,nlayer) *
      $            (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
              !O3p interpolated coefficient
              jfotsout(indexint,3,auxi) = 
-     $            jfotsout(indexint,3,klev) *
+     $            jfotsout(indexint,3,nlayer) *
      $            (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
              !CO2 interpolated coefficient
              jfotsout(indexint,1,auxi) = 
-     $            jfotsout(indexint,1,klev) *
+     $            jfotsout(indexint,1,nlayer) *
      $            (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
              !H2 interpolated coefficient
              jfotsout(indexint,5,auxi) = 
-     $            jfotsout(indexint,5,klev) *
+     $            jfotsout(indexint,5,nlayer) *
      $            (wm(i)*auxjh2(ind+1) + wp(i)*auxjh2(ind))
              !N2 interpolated coefficient
              jfotsout(indexint,8,auxi) = 
-     $            jfotsout(indexint,8,klev) *
+     $            jfotsout(indexint,8,nlayer) *
      $            (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind))
              !CO interpolated coefficient
              jfotsout(indexint,11,auxi) = 
-     $            jfotsout(indexint,11,klev) *
+     $            jfotsout(indexint,11,nlayer) *
      $            (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind))
              !H interpolated coefficient
              jfotsout(indexint,12,auxi) = 
-     $            jfotsout(indexint,12,klev) *
+     $            jfotsout(indexint,12,nlayer) *
      $            (wm(i)*auxjh(ind+1) + wp(i)*auxjh(ind))
           enddo
           !Only if chemthermod.ge.2
           if(chemthermod.ge.2) then
-             do i=1,klev
+             do i=1,nlayer
                 ind=auxind(i)
-                auxi = klev-i+1
+                auxi = nlayer-i+1
                 !N interpolated coefficient
                 jfotsout(indexint,9,auxi) = 
-     $               jfotsout(indexint,9,klev) *
+     $               jfotsout(indexint,9,nlayer) *
      $               (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
                 !NO interpolated coefficient
                 jfotsout(indexint,10,auxi)=
-     $               jfotsout(indexint,10,klev) *
+     $               jfotsout(indexint,10,nlayer) *
      $               (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind))
                 !NO2 interpolated coefficient
                 jfotsout(indexint,13,auxi)=
-     $               jfotsout(indexint,13,klev) *
+     $               jfotsout(indexint,13,nlayer) *
      $               (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
              enddo
@@ -370,6 +367,6 @@
 c     Input atmospheric column
       indexint=16
-      do i=1,klev
-         auxcolinp(klev-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $        o2colx(i)*crscabsi2(2,indexint)+
      $        o3pcolx(i)*crscabsi2(3,indexint)+
@@ -417,45 +414,45 @@
 
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = klev-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,klev) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !CO2 interpolated coefficient
-         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,klev) *
+         jfotsout(indexint,1,auxi) = jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind))
          !O3p interpolated coefficient
-         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,klev) *
+         jfotsout(indexint,3,auxi) = jfotsout(indexint,3,nlayer) *
      $        (wm(i)*auxjo3p(ind+1) + wp(i)*auxjo3p(ind))
          !N2 interpolated coefficient
-         jfotsout(indexint,8,auxi) = jfotsout(indexint,8,klev) *
+         jfotsout(indexint,8,auxi) = jfotsout(indexint,8,nlayer) *
      $        (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind))
          !CO interpolated coefficient
          jfotsout(indexint,11,auxi) = 
-     $        jfotsout(indexint,11,klev) *
+     $        jfotsout(indexint,11,nlayer) *
      $        (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind))
          !H interpolated coefficient
          jfotsout(indexint,12,auxi) = 
-     $        jfotsout(indexint,12,klev) *
+     $        jfotsout(indexint,12,nlayer) *
      $        (wm(i)*auxjh(ind+1) + wp(i)*auxjh(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = klev-i+1
+            auxi = nlayer-i+1
             !N interpolated coefficient
             jfotsout(indexint,9,auxi) = 
-     $           jfotsout(indexint,9,klev) *
+     $           jfotsout(indexint,9,nlayer) *
      $           (wm(i)*auxjn(ind+1) + wp(i)*auxjn(ind))
             !NO interpolated coefficient
             jfotsout(indexint,10,auxi) = 
-     $           jfotsout(indexint,10,klev) * 
+     $           jfotsout(indexint,10,nlayer) * 
      $           (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind))
             !NO2 interpolated coefficient
             jfotsout(indexint,13,auxi) = 
-     $           jfotsout(indexint,13,klev) *
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -473,6 +470,6 @@
 c     Input column
 
-      do i=1,klev
-         auxcolinp(klev-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
      $        nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -507,9 +504,9 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
          !Correction to include T variation of CO2 cross section
          if(indexint.eq.24) then
-            do i=1,klev
-               auxi = klev-i+1
+            do i=1,nlayer
+               auxi = nlayer-i+1
                if(sigma(indexint,auxi)*
      $              alfa(indexint,auxi)*coltemp(auxi)
@@ -522,19 +519,19 @@
             enddo
          else
-            do i=1,klev
+            do i=1,nlayer
                cortemp(i)=1.
             enddo
          end if
-         do i=1,klev           
+         do i=1,nlayer           
             ind=auxind(i)
-            auxi = klev-i+1
+            auxi = nlayer-i+1
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,klev) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,klev) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) 
      $           * cortemp(i)
@@ -545,10 +542,10 @@
             !N2 interpolated coefficient
             jfotsout(indexint,8,auxi) = 
-     $           jfotsout(indexint,8,klev) *
+     $           jfotsout(indexint,8,nlayer) *
      $           (wm(i)*auxjn2(ind+1) + wp(i)*auxjn2(ind)) * 
      $           cortemp(i)            
             !CO interpolated coefficient
             jfotsout(indexint,11,auxi) = 
-     $           jfotsout(indexint,11,klev) *
+     $           jfotsout(indexint,11,nlayer) *
      $           (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind)) * 
      $           cortemp(i)            
@@ -556,15 +553,15 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,klev
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = klev-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,klev) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $              cortemp(i)
                !NO2 interpolated coefficient
                jfotsout(indexint,13,auxi)=
-     $              jfotsout(indexint,13,klev) *
+     $              jfotsout(indexint,13,nlayer) *
      $              (wm(i)*auxjno2(ind+1)+ wp(i)*auxjno2(ind)) * 
      $              cortemp(i)
@@ -585,6 +582,6 @@
 c     Input atmospheric column
 
-      do i=1,klev
-         auxcolinp(klev-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -620,8 +617,8 @@
          endif
          call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-         do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = klev-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -634,5 +631,5 @@
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,klev) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) * 
      $           cortemp(i) *
@@ -641,20 +638,20 @@
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,klev) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !H2O interpolated coefficient
             jfotsout(indexint,4,auxi) = 
-     $           jfotsout(indexint,4,klev) *
+     $           jfotsout(indexint,4,nlayer) *
      $           (wm(i)*auxjh2o(ind+1) + wp(i)*auxjh2o(ind)) * 
      $           cortemp(i)
             !H2O2 interpolated coefficient
             jfotsout(indexint,6,auxi) = 
-     $           jfotsout(indexint,6,klev) *
+     $           jfotsout(indexint,6,nlayer) *
      $           (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $           cortemp(i)            
             !CO interpolated coefficient
             jfotsout(indexint,11,auxi) = 
-     $           jfotsout(indexint,11,klev) *
+     $           jfotsout(indexint,11,nlayer) *
      $           (wm(i)*auxjco(ind+1) + wp(i)*auxjco(ind)) * 
      $           cortemp(i)
@@ -662,15 +659,15 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,klev
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = klev-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,klev) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $              cortemp(i)
                !NO2 interpolated coefficient
                jfotsout(indexint,13,auxi)=
-     $              jfotsout(indexint,13,klev) *
+     $              jfotsout(indexint,13,nlayer) *
      $              (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind)) * 
      $              cortemp(i)
@@ -693,6 +690,6 @@
 c     Input atmospheric column
 
-      do i=1,klev
-         auxcolinp(klev-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + no2colx(i)
       end do
@@ -727,8 +724,8 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-         do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = klev-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -741,5 +738,5 @@
             !CO2 interpolated coefficient
             jfotsout(indexint,1,auxi) = 
-     $           jfotsout(indexint,1,klev) *
+     $           jfotsout(indexint,1,nlayer) *
      $           (wm(i)*auxjco2(ind+1) + wp(i)*auxjco2(ind)) * 
      $           cortemp(i) *
@@ -748,15 +745,15 @@
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = 
-     $           jfotsout(indexint,2,klev) *
+     $           jfotsout(indexint,2,nlayer) *
      $           (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $           cortemp(i)
             !H2O interpolated coefficient
             jfotsout(indexint,4,auxi) = 
-     $           jfotsout(indexint,4,klev) *
+     $           jfotsout(indexint,4,nlayer) *
      $           (wm(i)*auxjh2o(ind+1) + wp(i)*auxjh2o(ind)) * 
      $           cortemp(i)
             !H2O2 interpolated coefficient
             jfotsout(indexint,6,auxi) = 
-     $           jfotsout(indexint,6,klev) *
+     $           jfotsout(indexint,6,nlayer) *
      $           (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $           cortemp(i)            
@@ -764,10 +761,10 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,klev 
+            do i=1,nlayer 
                ind=auxind(i)
-               auxi = klev-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=
-     $              jfotsout(indexint,10,klev) *
+     $              jfotsout(indexint,10,nlayer) *
      $              (wm(i)*auxjno(ind+1) +wp(i)*auxjno(ind)) * 
      $              cortemp(i)
@@ -795,6 +792,6 @@
 
       indexint=32
-      do i=1,klev
-         auxcolinp(klev-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
      $        nocolx(i) + no2colx(i)
       end do
@@ -824,10 +821,10 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = klev-i+1
+         auxi = nlayer-i+1
          !Correction to include T variation of CO2 cross section
-         if(sigma(indexint,klev-i+1)*alfa(indexint,auxi)*
+         if(sigma(indexint,nlayer-i+1)*alfa(indexint,auxi)*
      $        coltemp(auxi).lt.60.) then
             cortemp(i)=exp(-sigma(indexint,auxi)*
@@ -838,5 +835,5 @@
          !CO2 interpolated coefficient
          jfotsout(indexint,1,auxi) = 
-     $        jfotsout(indexint,1,klev) *
+     $        jfotsout(indexint,1,nlayer) *
      $        (wm(i)*auxjco2(ind+1)+wp(i)*auxjco2(ind)) * 
      $        cortemp(i) *
@@ -845,10 +842,10 @@
          !O2 interpolated coefficient
          jfotsout(indexint,2,auxi) = 
-     $        jfotsout(indexint,2,klev) *
+     $        jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind)) * 
      $        cortemp(i)
          !H2O2 interpolated coefficient
          jfotsout(indexint,6,auxi) = 
-     $        jfotsout(indexint,6,klev) *
+     $        jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind)) * 
      $        cortemp(i)         
@@ -856,15 +853,15 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,klev
-            auxi = klev-i+1
+         do i=1,nlayer
+            auxi = nlayer-i+1
             ind=auxind(i)
             !NO interpolated coefficient
             jfotsout(indexint,10,auxi) = 
-     $           jfotsout(indexint,10,klev) * 
+     $           jfotsout(indexint,10,nlayer) * 
      $           (wm(i)*auxjno(ind+1) + wp(i)*auxjno(ind)) * 
      $           cortemp(i)
            !NO2 interpolated coefficient
             jfotsout(indexint,13,auxi) = 
-     $           jfotsout(indexint,13,klev) *
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind)) * 
      $           cortemp(i)
@@ -885,6 +882,6 @@
 
       indexint=33
-      do i=1,klev
-         auxcolinp(klev-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
       end do
 
@@ -908,22 +905,22 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = klev-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,klev) *
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) *
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,klev) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,klev-i+1) = 
-     $           jfotsout(indexint,13,klev) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -943,6 +940,6 @@
 
       indexint=34
-      do i=1,klev
-         auxcolinp(klev-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
      $        no2colx(i)
       end do
@@ -969,25 +966,25 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = klev-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
-         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,klev) * 
+         jfotsout(indexint,2,auxi) = jfotsout(indexint,2,nlayer) * 
      $        (wm(i)*auxjo2(ind+1) + wp(i)*auxjo2(ind))
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,klev) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
          !O3 interpolated coefficient
-         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,klev) *
+         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,klev-i+1) = 
-     $           jfotsout(indexint,13,klev) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -1007,6 +1004,6 @@
 
       indexint=35
-      do i=1,klev
-         auxcolinp(klev-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
       end do
 
@@ -1030,21 +1027,21 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = klev-i+1
+         auxi = nlayer-i+1
          !H2O2 interpolated coefficient
-         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,klev) *
+         jfotsout(indexint,6,auxi) = jfotsout(indexint,6,nlayer) *
      $        (wm(i)*auxjh2o2(ind+1) + wp(i)*auxjh2o2(ind))
          !O3 interpolated coefficient
-         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,klev) *
+         jfotsout(indexint,7,auxi) = jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,klev-i+1) = 
-     $           jfotsout(indexint,13,klev) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -1063,6 +1060,6 @@
 
       indexint=36
-      do i=1,klev
-         auxcolinp(klev-i+1) = o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o3colx(i) + no2colx(i)
       end do
 
